#include <p32xxxx.h>			// always in first place to avoid conflict with const.h ON
#include "utype.h"

volatile int g_Timer=0;

//void Tmr1Interrupt(void) __attribute__((interrupt,nomips16,noinline));

// Put the ISR_wrapper in the good place
//void ISR_wrapper_vector_4(void) __attribute__((section(".vector_4")))
//{
//	Tmr1Interrupt();
//}
// ISR_wrapper will call the Tmr1Interrupt()


// define here the code to execute when an interrupt occure
void __attribute__((interrupt,nomips16,noinline)) _Tmr1Interrupt(void)
{
	if (IFS0bits.T1IF) {	// Timer Interrupt flag
		TMR1=0;				// reset the timer register
		IFS0CLR=0x10;		// Clear the timer interrupt flag
		g_Timer++;		// increment the counter
	}
}

// configure timer 1
void init_timer1(void)
{
//	IntConfigureSystem(INT_SYSTEM_CONFIG_MULT_VECTOR);	// interrupt mode (interrupt.c)
//	_CP0_SET_EBASE(0xBFC00000); // Set an EBase value of 0xBFC00000	

/*
^C}16rbg񓯊JE^ [hɐݒ肷ɂ́AL̎菇sKv
܂B
1. ^C}𖳌ɂ: ONrbg(T1CON<15>) =0
2. ONbNLɂ: TCSrbg(T1CON<1>) =1
3. NbN𖳌ɂ: TSYNCrbg(T1CON<2>) =0
4. K؂ȃvXP[I
5. ^C}WX^TMR1ɒlނNA
6. vgꍇAWX^PR1ɓK؂16rbgvl
7. 荞݂gꍇ:
	a) IFSxWX^T1IF荞݃tOrbgNA
	b) IPCxWX^Ŋ荞݂̗DxƕDxݒ肷
	c) IECxWX^T1IE荞݃Cl[urbgZbg
8. ^C}Lɂ: ONrbg(T1CON<15>) =1
*/
	T1CON=0;			// reset timer 1 configuration
	TMR1=0;				// reset timer 1 counter register
	PR1=50000;			// define the preload register

	IPC1SET=0x7;		// select interrupt priority and sub-priority
	IFS0CLR=0x10;		// clear interrupt flag
	IEC0SET=0x10;		// enable timer 1 interrupt
	T1CONSET=0x8010;	// start timer 1 and set prescaler(1/8)
/*	CPU=40MHẑƂ
		TPB=50nS(20MHz) PrescalerOut=400nS(2.5MHz)
		PR1=2500Ȃ 1kHz
 		PR1=25000Ȃ 100Hz
 */
/*
T1CON
bit 15 ON: Timer ONrbg(1)
		1= ^C}Lɂ
		0= ^C}𖳌ɂ
bit 14 :u0vƂēǂݏo
bit 13 SIDL: ACh[h~rbg
		1= foCXACh[hɈڍsɓ~
		0= foCXACh[hɈڍsĂp
bit 12 TWDIS: 񓯊^C}݃fBZ[u rbg
		1= ۗ̏ݓ삪܂TMR1ւ݂̏𖳎
		0= AIȏ݂\ɂ(KV[̔񓯊^C}@\)
bit 11 TWIP: 񓯊^C}ݒXe[^Xrbg
		񓯊^C}[h̏ꍇ:
		1= TMR1WX^ւ̔񓯊݂s
		0= TMR1WX^ւ̔񓯊݂͊
		^C}[h̏ꍇ:
		̃rbg͏Ɂu0vƂēǂݏo܂B
bit 10-8 :u0vƂēǂݏo
bit 7 TGATE: ^C}Q[gԐώZCl[urbg
	TCS =1̏ꍇ:
	̃rbg͖܂B
	TCS =0̏ꍇ:
	1= Q[gԐώZLɂ
	0= Q[gԐώZ𖳌ɂ
bit 6 :u0vƂēǂݏo
bit 5-4 TCKPS<1:0>: ^C}̓NbN vXP[Irbg
	11= 1:256vXP[l
	10= 1:64vXP[l
	01= 1:8vXP[l
	00= 1:1vXP[l
bit 3 :u0vƂēǂݏo
*/
}

int	 get_timer1()
{
	return g_Timer;
}
void set_timer1(int t)
{
	g_Timer=t;
}
